# Class VulkanPipelineColorBlendStateCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineColorBlendStateCreateInfo

All Implemented Interfaces:
  `VulkanPipelineColorBlendStateCreateInfoType`

public final class VulkanPipelineColorBlendStateCreateInfo extends Object implements VulkanPipelineColorBlendStateCreateInfoType
Structure specifying parameters of a newly created pipeline color blend state.

See Also:
  - "VkPipelineColorBlendStateCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineColorBlendStateCreateInfo.Builder`
  Builds instances of type `VulkanPipelineColorBlendStateCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<VulkanPipelineColorBlendAttachmentState>`
  `attachments()`
  `VulkanBlendConstants`
  `blendConstants()`
  `static VulkanPipelineColorBlendStateCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineColorBlendStateCreateInfo`.
  `static VulkanPipelineColorBlendStateCreateInfo`
  `copyOf(VulkanPipelineColorBlendStateCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineColorBlendStateCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineColorBlendStateCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineColorBlendStateCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `logicOp`, `flags`, `attachments`, `blendConstants`.
  `Optional<VulkanLogicOp>`
  `logicOp()`
  `static VulkanPipelineColorBlendStateCreateInfo`
  `of(Optional<? extends VulkanLogicOp> logicOp, Iterable<VulkanPipelineColorBlendStateCreateFlag> flags, Iterable<? extends VulkanPipelineColorBlendAttachmentState> attachments, VulkanBlendConstants blendConstants)`
  Construct a new immutable `VulkanPipelineColorBlendStateCreateInfo` instance.
  `static VulkanPipelineColorBlendStateCreateInfo`
  `of(Optional<VulkanLogicOp> logicOp, Set<VulkanPipelineColorBlendStateCreateFlag> flags, List<VulkanPipelineColorBlendAttachmentState> attachments, VulkanBlendConstants blendConstants)`
  Construct a new immutable `VulkanPipelineColorBlendStateCreateInfo` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineColorBlendStateCreateInfo` with attribute values.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withAttachments(VulkanPipelineColorBlendAttachmentState... elements)`
  Copy the current immutable object with elements that replace the content of `attachments`.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withAttachments(Iterable<? extends VulkanPipelineColorBlendAttachmentState> elements)`
  Copy the current immutable object with elements that replace the content of `attachments`.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withBlendConstants(VulkanBlendConstants value)`
  Copy the current immutable object by setting a value for the `blendConstants` attribute.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withFlags(VulkanPipelineColorBlendStateCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withFlags(Iterable<VulkanPipelineColorBlendStateCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withLogicOp(VulkanLogicOp value)`
  Copy the current immutable object by setting a present value for the optional `logicOp` attribute.
  `final VulkanPipelineColorBlendStateCreateInfo`
  `withLogicOp(Optional<? extends VulkanLogicOp> optional)`
  Copy the current immutable object by setting an optional value for the `logicOp` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### logicOp

    public Optional<VulkanLogicOp> logicOp()
    Specified by:
      `logicOp` in interface `VulkanPipelineColorBlendStateCreateInfoType`
    Returns:
      The logical operation to apply (if any)

  - ### flags

    public Set<VulkanPipelineColorBlendStateCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineColorBlendStateCreateInfoType`
    Returns:
      The creation flags

  - ### attachments

    public List<VulkanPipelineColorBlendAttachmentState> attachments()
    Specified by:
      `attachments` in interface `VulkanPipelineColorBlendStateCreateInfoType`
    Returns:
      The per-target attachment states.

  - ### blendConstants

    public VulkanBlendConstants blendConstants()
    Specified by:
      `blendConstants` in interface `VulkanPipelineColorBlendStateCreateInfoType`
    Returns:
      The constants used for blending

  - ### withLogicOp

    public final VulkanPipelineColorBlendStateCreateInfo withLogicOp(VulkanLogicOp value)
    Copy the current immutable object by setting a present value for the optional `logicOp` attribute.
    Parameters:
      `value` - The value for logicOp
    Returns:
      A modified copy of `this` object

  - ### withLogicOp

    public final VulkanPipelineColorBlendStateCreateInfo withLogicOp(Optional<? extends VulkanLogicOp> optional)
    Copy the current immutable object by setting an optional value for the `logicOp` attribute. An equality check is used on inner nullable value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - A value for logicOp
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineColorBlendStateCreateInfo withFlags(VulkanPipelineColorBlendStateCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineColorBlendStateCreateInfo withFlags(Iterable<VulkanPipelineColorBlendStateCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withAttachments

    public final VulkanPipelineColorBlendStateCreateInfo withAttachments(VulkanPipelineColorBlendAttachmentState... elements)
    Copy the current immutable object with elements that replace the content of `attachments`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withAttachments

    public final VulkanPipelineColorBlendStateCreateInfo withAttachments(Iterable<? extends VulkanPipelineColorBlendAttachmentState> elements)
    Copy the current immutable object with elements that replace the content of `attachments`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of attachments elements to set
    Returns:
      A modified copy of `this` object

  - ### withBlendConstants

    public final VulkanPipelineColorBlendStateCreateInfo withBlendConstants(VulkanBlendConstants value)
    Copy the current immutable object by setting a value for the `blendConstants` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for blendConstants
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineColorBlendStateCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `logicOp`, `flags`, `attachments`, `blendConstants`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineColorBlendStateCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanPipelineColorBlendStateCreateInfo of(Optional<VulkanLogicOp> logicOp, Set<VulkanPipelineColorBlendStateCreateFlag> flags, List<VulkanPipelineColorBlendAttachmentState> attachments, VulkanBlendConstants blendConstants)
    Construct a new immutable `VulkanPipelineColorBlendStateCreateInfo` instance.
    Parameters:
      `logicOp` - The value for the `logicOp` attribute
      `flags` - The value for the `flags` attribute
      `attachments` - The value for the `attachments` attribute
      `blendConstants` - The value for the `blendConstants` attribute
    Returns:
      An immutable VulkanPipelineColorBlendStateCreateInfo instance

  - ### of

    public static VulkanPipelineColorBlendStateCreateInfo of(Optional<? extends VulkanLogicOp> logicOp, Iterable<VulkanPipelineColorBlendStateCreateFlag> flags, Iterable<? extends VulkanPipelineColorBlendAttachmentState> attachments, VulkanBlendConstants blendConstants)
    Construct a new immutable `VulkanPipelineColorBlendStateCreateInfo` instance.
    Parameters:
      `logicOp` - The value for the `logicOp` attribute
      `flags` - The value for the `flags` attribute
      `attachments` - The value for the `attachments` attribute
      `blendConstants` - The value for the `blendConstants` attribute
    Returns:
      An immutable VulkanPipelineColorBlendStateCreateInfo instance

  - ### copyOf

    public static VulkanPipelineColorBlendStateCreateInfo copyOf(VulkanPipelineColorBlendStateCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineColorBlendStateCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineColorBlendStateCreateInfo instance

  - ### builder

    public static VulkanPipelineColorBlendStateCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineColorBlendStateCreateInfo`.

         VulkanPipelineColorBlendStateCreateInfo.builder()
            .setLogicOp(com.io7m.jcoronado.api.VulkanLogicOp) // optional logicOp
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineColorBlendStateCreateFlag) // flags elements
            .addAttachments|addAllAttachments(VulkanPipelineColorBlendAttachmentState) // attachments elements
            .setBlendConstants(com.io7m.jcoronado.api.VulkanBlendConstants) // optional blendConstants
            .build();

    Returns:
      A new VulkanPipelineColorBlendStateCreateInfo builder